Index: LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 4062)
+++ LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 4063)
@@ -1325,5 +1352,5 @@
   INTEGER,          OPTIONAL, INTENT(IN) :: igen
   INTEGER :: ig, ix
-  ig = 1; IF(PRESENT(igen)) ig = igen
+  ig = 0; IF(PRESENT(igen)) ig = igen
   IF(     PRESENT(tname)) out = [(idxAncestor_1(t, tname(ix),  ig), ix=1, SIZE(tname))]
   IF(.NOT.PRESENT(tname)) out = [(idxAncestor_1(t, t(ix)%name, ig), ix=1, SIZE(t))]
Index: LMDZ6/trunk/libf/misc/strings_mod.F90
===================================================================
--- LMDZ6/trunk/libf/misc/strings_mod.F90	(revision 4062)
+++ LMDZ6/trunk/libf/misc/strings_mod.F90	(revision 4063)
@@ -106,5 +106,5 @@
   INTEGER,          OPTIONAL, INTENT(IN) :: unit
   INTEGER :: unt
-  IF(PRESENT(ll)) THEN; IF(ll) RETURN; END IF
+  IF(PRESENT(ll)) THEN; IF(.NOT.ll) RETURN; END IF
   unt = lunout; IF(PRESENT(unit)) unt = unit
   IF(PRESENT(modname)) THEN
@@ -124,17 +124,17 @@
   CHARACTER(LEN=maxlen), ALLOCATABLE :: s(:)
   INTEGER :: unt, nmx, k
-  LOGICAL :: lerr
-  lerr = .TRUE.; IF(PRESENT(ll))  lerr = ll
-  unt = lunout ; IF(PRESENT(unit)) unt = unit
-  nmx = 128;     IF(PRESENT(nmax)) nmx = nmax
+  LOGICAL :: l
+  l   = .TRUE.; IF(PRESENT(ll))     l = ll
+  unt = lunout; IF(PRESENT(unit)) unt = unit
+  nmx = 128;    IF(PRESENT(nmax)) nmx = nmax
   s = strStackm(str, ', ', nmx)
   IF(PRESENT(modname)) THEN
-    DO k=1,SIZE(s); CALL msg_1(s(k), modname, lerr, unt); END DO
+    DO k=1,SIZE(s); CALL msg_1(s(k), modname, l, unt); END DO
   ELSE
-    DO k=1,SIZE(s); CALL msg_1(s(k), ll=lerr, unit=unt);  END DO
+    DO k=1,SIZE(s); CALL msg_1(s(k), ll=l, unit=unt);  END DO
   END IF
 END SUBROUTINE msg_m
 !==============================================================================================================================
-LOGICAL FUNCTION fmsg_1(str, modname, ll, unit) RESULT(lerr)
+LOGICAL FUNCTION fmsg_1(str, modname, ll, unit) RESULT(l)
   CHARACTER(LEN=*),           INTENT(IN) :: str
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
@@ -142,14 +142,14 @@
   INTEGER,          OPTIONAL, INTENT(IN) :: unit
   INTEGER :: unt
-  lerr = .TRUE.; IF(PRESENT(ll))  lerr = ll
-  unt = lunout ; IF(PRESENT(unit)) unt = unit
+  l   = .TRUE.; IF(PRESENT(ll))     l = ll
+  unt = lunout; IF(PRESENT(unit)) unt = unit
   IF(PRESENT(modname)) THEN
-    CALL msg_1(str, modname, lerr, unt)
+    CALL msg_1(str, modname, l, unt)
   ELSE
-    CALL msg_1(str, ll=lerr, unit=unt)
+    CALL msg_1(str, ll=l, unit=unt)
   END IF
 END FUNCTION fmsg_1
 !==============================================================================================================================
-LOGICAL FUNCTION fmsg_m(str, modname, ll, unit, nmax) RESULT(lerr)
+LOGICAL FUNCTION fmsg_m(str, modname, ll, unit, nmax) RESULT(l)
   CHARACTER(LEN=*),           INTENT(IN)  :: str(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
@@ -158,11 +158,11 @@
   INTEGER,          OPTIONAL, INTENT(IN)  :: nmax
   INTEGER :: unt, nmx
-  lerr = .TRUE.; IF(PRESENT(ll))  lerr = ll
-  unt = lunout ; IF(PRESENT(unit)) unt = unit
-  nmx = 128;     IF(PRESENT(nmax)) nmx = nmax
+  l   = .TRUE.; IF(PRESENT(ll))     l = ll
+  unt = lunout; IF(PRESENT(unit)) unt = unit
+  nmx = 128;    IF(PRESENT(nmax)) nmx = nmax
   IF(PRESENT(modname)) THEN
-    CALL msg_m(str, modname, lerr, unt, nmx)
+    CALL msg_m(str, modname, l, unt, nmx)
   ELSE
-    CALL msg_m(str, ll=lerr, unit=unt, nmax=nmx)
+    CALL msg_m(str, ll=l, unit=unt, nmax=nmx)
   END IF
 END FUNCTION fmsg_m
@@ -267,13 +267,20 @@
 !=== Concatenates the strings "str(:)" with separator "sep" into a single string using a separator (',' by default). ==========
 !==============================================================================================================================
-FUNCTION strStack(str, sep) RESULT(out)
+FUNCTION strStack(str, sep, mask) RESULT(out)
   CHARACTER(LEN=:),          ALLOCATABLE :: out
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
+  LOGICAL,          OPTIONAL, INTENT(IN) :: mask(:)
   CHARACTER(LEN=:), ALLOCATABLE :: s
-  INTEGER :: is
+  INTEGER :: is, i0
   IF(SIZE(str) == 0) THEN; out = ''; RETURN; END IF
   ALLOCATE(s, SOURCE=', '); IF(PRESENT(sep)) s=sep
-  out = str(1); DO is=2,SIZE(str, DIM=1); out = TRIM(out)//s//TRIM(str(is)); END DO
+  IF(PRESENT(mask)) THEN
+    IF(ALL(.NOT.mask)) THEN; out = ''; RETURN; END IF
+    i0 = 0; DO WHILE(.NOT.mask(i0+1)); i0 = i0+1; END DO
+    out = str(i0); DO is=i0+1,SIZE(str, DIM=1); IF(.NOT.mask(is)) CYCLE; out = TRIM(out)//s//TRIM(str(is)); END DO
+  ELSE
+    out = str(1); DO is=2,SIZE(str, DIM=1); out = TRIM(out)//s//TRIM(str(is)); END DO
+  END IF
 END FUNCTION strStack
 !==============================================================================================================================
Index: LMDZ6/trunk/libf/misc/trac_types_mod.F90
===================================================================
--- LMDZ6/trunk/libf/misc/trac_types_mod.F90	(revision 4062)
+++ LMDZ6/trunk/libf/misc/trac_types_mod.F90	(revision 4063)
@@ -22,5 +22,5 @@
     CHARACTER(LEN=maxlen) :: component                     !--- Coma-separated list of components (Ex: lmdz,inca)
     INTEGER               :: iadv        = 10              !--- Advection scheme used
-    INTEGER               :: iGeneration = 1               !--- Generation number (>=1)
+    INTEGER               :: iGeneration = -1              !--- Generation number (>=0)
     LOGICAL               :: isAdvected  = .FALSE.         !--- "true" tracers: iadv > 0 . COUNT(     isAdvected) =nqtrue
     LOGICAL               :: isH2Ofamily = .FALSE.         !--- H2O tracers/isotopes/tags. COUNT(.NOT.isH2Ofamily)=nqtottr
@@ -40,14 +40,14 @@
     LOGICAL                            :: check=.FALSE.    !--- Triggering of the checking routines
     TYPE(keys_type),       ALLOCATABLE :: keys(:)          !--- Isotopes keys/values pairs list     (length: niso)
-    CHARACTER(LEN=maxlen), ALLOCATABLE :: trac(:)          !--- Isotopes + tagging tracers list     (length: nitr)
-    CHARACTER(LEN=maxlen), ALLOCATABLE :: zone(:)          !--- Geographic tagging zones names list (length: nzon)
-    CHARACTER(LEN=maxlen)              :: phase = 'g'      !--- Phases list: [g][l][s]              (length: npha)
-    INTEGER                            :: niso = 0         !--- Number of isotopes, excluding tagging tracers
-    INTEGER                            :: nzon = 0         !--- Number of geographic tagging zones
-    INTEGER                            :: nitr = 0         !--- Number of isotopes, including tagging tracers
-    INTEGER                            :: npha = 0         !--- Number phases
-    INTEGER,               ALLOCATABLE :: iTraPha(:,:)     !--- Idx in "trac(1:niso)" = f(name(1:nitr)),phas)
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: trac(:)          !--- Isotopes + tagging tracers list     (length: ntiso)
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: zone(:)          !--- Geographic tagging zones names list (length: nzone)
+    CHARACTER(LEN=maxlen)              :: phase = 'g'      !--- Phases list: [g][l][s]              (length: nphas)
+    INTEGER                            :: niso  = 0        !--- Number of isotopes, excluding tagging tracers
+    INTEGER                            :: nzone = 0        !--- Number of geographic tagging zones
+    INTEGER                            :: ntiso = 0        !--- Number of isotopes, including tagging tracers
+    INTEGER                            :: nphas = 0        !--- Number phases
+    INTEGER,               ALLOCATABLE :: iTraPha(:,:)     !--- Idx in "trac(1:niso)" = f(name(1:ntiso)),phas)
                                                            !---        "iTraPha" former name: "iqiso"
-    INTEGER,               ALLOCATABLE :: iZonIso(:,:)     !--- Idx in "trac(1:nitr)" = f(zone, name(1:niso))
+    INTEGER,               ALLOCATABLE :: iZonIso(:,:)     !--- Idx in "trac(1:ntiso)" = f(zone, name(1:niso))
                                                            !---        "iZonIso" former name: "index_trac"
   END TYPE isot_type
